﻿namespace HeuristicLab.BenchmarkSuite.ERC {
  using System.Linq;

  using HeuristicLab.Common;
  using HeuristicLab.Core;
  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class ErcOption<T> : NamedItem {

    public ErcOption() {
      Constants = new T[0];
    }

    public ErcOption(params T[] constants) {
      Constants = constants;
    }

    [StorableConstructor]
    public ErcOption(bool deserializing)
      : base(deserializing) {
      Constants = new T[0];
    }

    public ErcOption(ErcOption<T> origin, Cloner cloner) : base(origin, cloner) {
      this.Constants = origin.Constants.ToArray();
    }

    public T[] Constants { get; set; }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new ErcOption<T>(this, cloner);
    }
  }
}
