﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
  using System;

  using HeuristicLab.Core;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;

  public class PooledPushInterpreter : PushInterpreter, IDisposable {

    private readonly PushInterpreterPool pool;

    public PooledPushInterpreter(PushInterpreterPool pool, IReadOnlyPushConfiguration config, InterpreterPoolContainer poolContainer, IRandom random = null)
      : base(config, random, poolContainer) {
      this.pool = pool;
    }

    public void Dispose() {
      this.Reset();
      this.Configuration = this.Configuration;
      this.pool.Free(this);
    }
  }
}
